Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.ejb.access
Class SimpleRemoteSlsbInvokerInterceptor

    java.lang.Object
      org.springframework.jndi.JndiAccessor
          org.springframework.jndi.JndiLocatorSupport
              org.springframework.jndi.JndiObjectLocator
                  org.springframework.ejb.access.AbstractSlsbInvokerInterceptor
                      org.springframework.ejb.access.AbstractRemoteSlsbInvokerInterceptor
                          org.springframework.ejb.access.SimpleRemoteSlsbInvokerInterceptor

All Implemented Interfaces:
  org.aopalliance.aop.Advice, org.aopalliance.intercept.Interceptor, org.aopalliance.intercept.MethodInterceptor, DisposableBean, InitializingBean

Direct Known Subclasses:
  SimpleRemoteStatelessSessionProxyFactoryBean

    public class SimpleRemoteSlsbInvokerInterceptor

extends AbstractRemoteSlsbInvokerInterceptor
implements DisposableBean

Basic invoker for a remote Stateless Session Bean. Designed for EJB 2.x, but works for EJB 3 Session Beans as well.

"Creates" a new EJB instance for each invocation, or caches the session bean instance for all invocations (see `setCacheSessionBean(boolean)`). See `JndiObjectLocator` for info on how to specify the JNDI location of the target EJB.

In a bean container, this class is normally best used as a singleton. However, if that bean container pre-instantiates singletons (as do the XML ApplicationContext variants) you may have a problem if the bean container is loaded before the EJB container loads the target EJB. That is because by default the JNDI lookup will be performed in the init method of this class and cached, but the EJB will not have been bound at the target location yet. The best solution is to set the "lookupHomeOnStartup" property to "false", in which case the home will be fetched on first access to the EJB. (This flag is only true by default for backwards compatibility reasons).

This invoker is typically used with an RMI business interface, which serves as super-interface of the EJB component interface. Alternatively, this invoker can also proxy a remote SLSB with a matching non-RMI business interface, i.e. an interface that mirrors the EJB business methods but does not declare RemoteExceptions. In the latter case, RemoteExceptions thrown by the EJB stub will automatically get converted to Spring's unchecked RemoteAccessException.

Since:
  09.05.2003
Author:
  Rod Johnson, Juergen Hoeller
See Also:
  `RemoteAccessException`, `AbstractSlsbInvokerInterceptor.setLookupHomeOnStartup(boolean)`, `AbstractSlsbInvokerInterceptor.setCacheHome(boolean)`, `AbstractRemoteSlsbInvokerInterceptor.setRefreshHomeOnConnectFailure(boolean)`

Field Summary

Fields inherited from class org.springframework.jndi.JndiLocatorSupport
`CONTAINER_PREFIX`

Fields inherited from class org.springframework.jndi.JndiAccessor
`logger`

Constructor Summary
`SimpleRemoteSlsbInvokerInterceptor()`

Method Summary
`void` | `destroy()` Remove the cached session bean instance, if necessary.
`protected java.lang.Object` | `doInvoke(org.aopalliance.intercept.MethodInvocation invocation)` This implementation "creates" a new EJB instance for each invocation.
`protected java.lang.Object` | `getSessionBeanInstance()` Return an EJB component instance to delegate the call to.
`protected void` | `refreshHome()` Reset the cached session bean instance, if necessary.
`protected void` | `releaseSessionBeanInstance(javax.ejb.EJBObject ejb)` Release the given EJB instance.
`void` | `setCacheSessionBean(boolean cacheSessionBean)` Set whether to cache the actual session bean object.

Methods inherited from class org.springframework.ejb.access.AbstractRemoteSlsbInvokerInterceptor
`getCreateMethod, invokeInContext, isConnectFailure, isHomeRefreshable, lookup, newSessionBeanInstance, refreshAndRetry, removeSessionBeanInstance, setHomeInterface, setRefreshHomeOnConnectFailure`

Methods inherited from class org.springframework.ejb.access.AbstractSlsbInvokerInterceptor
`afterPropertiesSet, create, getHome, invoke, setCacheHome, setExposeAccessContext, setLookupHomeOnStartup`

Methods inherited from class org.springframework.jndi.JndiObjectLocator
`getExpectedType, getJndiName, setExpectedType, setJndiName`

Methods inherited from class org.springframework.jndi.JndiLocatorSupport
`convertJndiName, isResourceRef, lookup, lookup, setResourceRef`

Methods inherited from class org.springframework.jndi.JndiAccessor
`getJndiEnvironment, getJndiTemplate, setJndiEnvironment, setJndiTemplate`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SimpleRemoteSlsbInvokerInterceptor

    public SimpleRemoteSlsbInvokerInterceptor()

Method Detail

### setCacheSessionBean

    public void setCacheSessionBean(boolean cacheSessionBean)

  Set whether to cache the actual session bean object.

  Off by default for standard EJB compliance. Turn this flag on to optimize session bean access for servers that are known to allow for caching the actual session bean object.

  See Also:
    `AbstractSlsbInvokerInterceptor.setCacheHome(boolean)`

### doInvoke

    protected java.lang.Object doInvoke(org.aopalliance.intercept.MethodInvocation invocation)
                                 throws java.lang.Throwable

  This implementation "creates" a new EJB instance for each invocation. Can be overridden for custom invocation strategies.

  Alternatively, override `getSessionBeanInstance()` and `releaseSessionBeanInstance(javax.ejb.EJBObject)` to change EJB instance creation, for example to hold a single shared EJB component instance.

  Specified by:
    `doInvoke` in class `AbstractRemoteSlsbInvokerInterceptor`
  Parameters:
    `invocation` - the AOP method invocation
  Returns:
    the invocation result, if any
  Throws:
    `java.lang.Throwable` - in case of invocation failure
  See Also:
    `AbstractSlsbInvokerInterceptor.getHome()`, `AbstractRemoteSlsbInvokerInterceptor.newSessionBeanInstance()`

### getSessionBeanInstance

    protected java.lang.Object getSessionBeanInstance()
                                               throws javax.naming.NamingException,
                                                      java.lang.reflect.InvocationTargetException

  Return an EJB component instance to delegate the call to.

  The default implementation delegates to `AbstractRemoteSlsbInvokerInterceptor.newSessionBeanInstance()`.

  Returns:
    the EJB component instance
  Throws:
    `javax.naming.NamingException` - if thrown by JNDI
    `java.lang.reflect.InvocationTargetException` - if thrown by the create method
  See Also:
    `AbstractRemoteSlsbInvokerInterceptor.newSessionBeanInstance()`

### releaseSessionBeanInstance

    protected void releaseSessionBeanInstance(javax.ejb.EJBObject ejb)

  Release the given EJB instance.

  The default implementation delegates to `AbstractRemoteSlsbInvokerInterceptor.removeSessionBeanInstance(javax.ejb.EJBObject)`.

  Parameters:
    `ejb` - the EJB component instance to release
  See Also:
    `AbstractRemoteSlsbInvokerInterceptor.removeSessionBeanInstance(javax.ejb.EJBObject)`

### refreshHome

    protected void refreshHome()
                        throws javax.naming.NamingException

  Reset the cached session bean instance, if necessary.

  Overrides:
    `refreshHome` in class `AbstractSlsbInvokerInterceptor`
  Throws:
    `javax.naming.NamingException` - if thrown by the JNDI lookup
  See Also:
    `JndiObjectLocator.lookup()`, `AbstractSlsbInvokerInterceptor.getCreateMethod(java.lang.Object)`

### destroy

    public void destroy()

  Remove the cached session bean instance, if necessary.

  Specified by:
    `destroy` in interface `DisposableBean`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD